final case class Operation(tags: List[String], summary: String = "", description: Doc, externalDocs: Option[ExternalDoc], operationId: Option[String], parameters: Set[ParameterOrReference], requestBody: Option[RequestBodyOrReference], responses: Responses, callbacks: Map[String, CallbackOrReference], deprecated: Boolean = false, security: List[SecurityRequirement], servers: List[Server]) extends OpenAPIBase with Product with Serializable

Describes a single API operation on a path.

tags

A list of tags for API documentation control. Tags can be used for logical grouping of operations by resources or any other qualifier.

summary

A short summary of what the operation does.

description

A verbose explanation of the operation behavior.

externalDocs

Additional external documentation for this operation.

operationId

Unique string used to identify the operation. The id MUST be unique among all operations described in the API. The operationId value is case-sensitive. Tools and libraries MAY use the operationId to uniquely identify an operation, therefore, it is RECOMMENDED to follow common programming naming conventions.

parameters

A List of parameters that are applicable for this operation. If a parameter is already defined at the Path Item, the new definition will override it but can never remove it. The list MUST NOT include duplicated parameters. A unique parameter is defined by a combination of a name and location. The list can use the Reference Object to link to parameters that are defined at the OpenAPI Object’s components/parameters.

requestBody

The request body applicable for this operation. The requestBody is only supported in HTTP methods where the HTTP 1.1 specification [RFC7231] has explicitly defined semantics for request bodies. In other cases where the HTTP spec is vague, requestBody SHALL be ignored by consumers.

responses

The List of possible responses as they are returned from executing this operation.

callbacks

A map of possible out-of band callbacks related to the parent operation. The key is a unique identifier for the Callback Object. Each value in the map is a Callback Object that describes a request that may be initiated by the API provider and the expected responses.

deprecated

Declares this operation to be deprecated. Consumers SHOULD refrain from usage of the declared operation.

security

A declaration of which security mechanisms can be used for this operation. The List of values includes alternative security requirement objects that can be used. Only one of the security requirement objects need to be satisfied to authorize a request. To make security optional, an empty security requirement ({}) can be included in the array. This definition overrides any declared top-level security. To remove a top-level security declaration, an empty List can be used.

servers

An alternative server List to service this operation. If an alternative server object is specified at the Path Item Object or Root level, it will be overridden by this value.

Linear Supertypes
Ordering
  1. Alphabetic
  2. By Inheritance
Inherited
  1. Operation
  2. Serializable
  3. Product
  4. Equals
  5. OpenAPIBase
  6. AnyRef
  7. Any
  1. Hide All
  2. Show All
Visibility
  1. Public
  2. Protected

Instance Constructors

  1. new Operation(tags: List[String], summary: String = "", description: Doc, externalDocs: Option[ExternalDoc], operationId: Option[String], parameters: Set[ParameterOrReference], requestBody: Option[RequestBodyOrReference], responses: Responses, callbacks: Map[String, CallbackOrReference], deprecated: Boolean = false, security: List[SecurityRequirement], servers: List[Server])

    tags

    A list of tags for API documentation control. Tags can be used for logical grouping of operations by resources or any other qualifier.

    summary

    A short summary of what the operation does.

    description

    A verbose explanation of the operation behavior.

    externalDocs

    Additional external documentation for this operation.

    operationId

    Unique string used to identify the operation. The id MUST be unique among all operations described in the API. The operationId value is case-sensitive. Tools and libraries MAY use the operationId to uniquely identify an operation, therefore, it is RECOMMENDED to follow common programming naming conventions.

    parameters

    A List of parameters that are applicable for this operation. If a parameter is already defined at the Path Item, the new definition will override it but can never remove it. The list MUST NOT include duplicated parameters. A unique parameter is defined by a combination of a name and location. The list can use the Reference Object to link to parameters that are defined at the OpenAPI Object’s components/parameters.

    requestBody

    The request body applicable for this operation. The requestBody is only supported in HTTP methods where the HTTP 1.1 specification [RFC7231] has explicitly defined semantics for request bodies. In other cases where the HTTP spec is vague, requestBody SHALL be ignored by consumers.

    responses

    The List of possible responses as they are returned from executing this operation.

    callbacks

    A map of possible out-of band callbacks related to the parent operation. The key is a unique identifier for the Callback Object. Each value in the map is a Callback Object that describes a request that may be initiated by the API provider and the expected responses.

    deprecated

    Declares this operation to be deprecated. Consumers SHOULD refrain from usage of the declared operation.

    security

    A declaration of which security mechanisms can be used for this operation. The List of values includes alternative security requirement objects that can be used. Only one of the security requirement objects need to be satisfied to authorize a request. To make security optional, an empty security requirement ({}) can be included in the array. This definition overrides any declared top-level security. To remove a top-level security declaration, an empty List can be used.

    servers

    An alternative server List to service this operation. If an alternative server object is specified at the Path Item Object or Root level, it will be overridden by this value.

Value Members

  1. final def !=(arg0: Any): Boolean
    Definition Classes
    AnyRef → Any
  2. final def ##: Int
    Definition Classes
    AnyRef → Any
  3. final def ==(arg0: Any): Boolean
    Definition Classes
    AnyRef → Any
  4. final def asInstanceOf[T0]: T0
    Definition Classes
    Any
  5. val callbacks: Map[String, CallbackOrReference]
  6. def clone(): AnyRef
    Attributes
    protected[lang]
    Definition Classes
    AnyRef
    Annotations
    @throws(classOf[java.lang.CloneNotSupportedException]) @native() @IntrinsicCandidate()
  7. val deprecated: Boolean
  8. val description: Doc
  9. final def eq(arg0: AnyRef): Boolean
    Definition Classes
    AnyRef
  10. val externalDocs: Option[ExternalDoc]
  11. final def getClass(): Class[_ <: AnyRef]
    Definition Classes
    AnyRef → Any
    Annotations
    @native() @IntrinsicCandidate()
  12. final def isInstanceOf[T0]: Boolean
    Definition Classes
    Any
  13. final def ne(arg0: AnyRef): Boolean
    Definition Classes
    AnyRef
  14. final def notify(): Unit
    Definition Classes
    AnyRef
    Annotations
    @native() @IntrinsicCandidate()
  15. final def notifyAll(): Unit
    Definition Classes
    AnyRef
    Annotations
    @native() @IntrinsicCandidate()
  16. val operationId: Option[String]
  17. val parameters: Set[ParameterOrReference]
  18. def productElementNames: Iterator[String]
    Definition Classes
    Product
  19. val requestBody: Option[RequestBodyOrReference]
  20. val responses: Responses
  21. val security: List[SecurityRequirement]
  22. val servers: List[Server]
  23. val summary: String
  24. final def synchronized[T0](arg0: => T0): T0
    Definition Classes
    AnyRef
  25. val tags: List[String]
  26. def toJson: String
    Definition Classes
    Operation → OpenAPIBase
  27. final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
    AnyRef
    Annotations
    @throws(classOf[java.lang.InterruptedException])
  28. final def wait(arg0: Long): Unit
    Definition Classes
    AnyRef
    Annotations
    @throws(classOf[java.lang.InterruptedException]) @native()
  29. final def wait(): Unit
    Definition Classes
    AnyRef
    Annotations
    @throws(classOf[java.lang.InterruptedException])

Deprecated Value Members

  1. def finalize(): Unit
    Attributes
    protected[lang]
    Definition Classes
    AnyRef
    Annotations
    @throws(classOf[java.lang.Throwable]) @Deprecated
    Deprecated

Inherited from Serializable

Inherited from Product

Inherited from Equals

Inherited from OpenAPIBase

Inherited from AnyRef

Inherited from Any

Ungrouped